unit WordStr;
(*
**
** Copyright (C) 1999-2003 Maarten Bekers. All rights reserved.
**
** This file is part of EleBBS, EleXer and EleWEB.
**
** This file may be distributed under the terms of the Q Public License
** as defined by Trolltech AS of Norway and appearing in the file
** LICENSE.QPL included in the packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
*)
{$I COMPILER.INC}
(*
**
** Words String utilies for EleBBS
**
** Copyright (c) 1996,97 by Maarten Bekers
**
** Created : 28-Mar-1998
** Last update : 28-Mar-1998
**
*)

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)
 INTERFACE
(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

uses CentrStr, Cases, CfgRec;

Const DefExtractWord   : CharSet = [#09, #32, ';'];

function  ExtractWord(const TempStr: String; Nr: Integer;
                      const CharAbortSet: CharSet;
                      const DoQuotes, IncludeEOS: Boolean): String;
function  Wordcount(TempStr: String; CharAbortSet: CharSet; DoQuotes: Boolean): Integer;
function  FirstWord(var s:String; CharAbortSet: CharSet; DoQuotes: Boolean):String; { first word of string & remove it }
function  LastWord(TempStr: String; CharAbortSet: CharSet; DoQuotes: Boolean): String;
function  GetValue(ID: String; var Str: String; Remove: Boolean): String; { Get ID from Str }
function  FirstNameOnly(Str: String): String;
function  LastNameOnly(Str: String): String;
procedure Replace(Const Zoek_Voor, Vervang_Door:String; Var Str : String);
function  InQuotes(S:String): String;
function  InitialString(FromWho: String): String;
function  GetCommaArgument(S: String; Nr:Byte): String;
procedure RemoveWordNr(var TempStr: String; Nr: Word; CharAbortSet: CharSet; DoQuotes: Boolean);
procedure DoWrap(var DestStr, LeftOver: String; MaxLen: Longint);
{$IFDEF MSDOS}
  function  FirstWordA(var s:String; CharAbortSet: CharSet; DoQuotes: Boolean):String; { first word of string & remove it }
  procedure RemoveWordNrA(var TempStr: String; Nr: Word; CharAbortSet: CharSet; DoQuotes: Boolean);
  procedure DoWrapA(var DestStr, LeftOver: String; MaxLen: Longint);
  procedure ReplaceA(Const Zoek_Voor, Vervang_Door:String; Var Str : String);
{$ELSE}
  function  FirstWordA(var s:AnsiString; CharAbortSet: CharSet; DoQuotes: Boolean):AnsiString;
                                         { first word of string & remove it }
  procedure RemoveWordNrA(var TempStr: AnsiString; Nr: Word; CharAbortSet: CharSet; DoQuotes: Boolean);
  procedure DoWrapA(var DestStr, LeftOver: AnsiString; MaxLen: Longint);
  procedure ReplaceA(Const Zoek_Voor, Vervang_Door:AnsiString; Var Str : AnsiString);
{$ENDIF}
procedure FilterString(var S: String; Chars: CharSet);
procedure RemoveChars(var S: String; Chars: CharSet);

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)
 IMPLEMENTATION
(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

function ExtractWord(const TempStr: String; Nr: Integer;
                     const CharAbortSet: CharSet;
                     const DoQuotes, IncludeEOS: Boolean): String;

Const DoBS = FALSE;

var Index       : Longint;
    CurrentWord : Longint;
    WordStr     : String;
begin
  Index := 01;
  CurrentWord := 00;
  WordStr := '';

  While ((Index) <= Length(TempStr)) AND (TempStr[Index] in CharAbortSet) do
    Inc(Index);

  While (Index <= Length(TempStr)) do
    begin
      if TempStr[Index] = '"' then
       if (TempStr[Index - 1] <> '\') OR (NOT DoBS) then
        if DoQuotes then
          begin
            WordStr := '';
            Inc(Index);

            While (Index <= Length(TempStr)) AND
                   ((TempStr[Index] <> '"') OR
                     ((TempStr[Index - 1] = '\') AND (DoBS))) do
              begin
                WordStr := WordStr + TempStr[Index];
                Inc(Index);
              end; { while }

            ExtractWord := WordStr;
            if CurrentWord + 01 = Nr then
               begin
                 Inc(CurrentWord);
                 BREAK;
               end; { if }

          end; { if }

      if TempStr[Index] in CharAbortSet then
        begin
          if IncludeEOS then WordStr := WordStr + TempStr[Index];

          Inc(CurrentWord);

          if CurrentWord <> Nr then WordStr := '';

          While ((Index + 01) <= Length(TempStr)) AND (TempStr[Index + 01] in CharAbortSet) do
             Inc(Index);
        end { if }
         else WordStr := WordStr + TempStr[Index];

      if CurrentWord = Nr then
        begin
          BREAK;
        end; { if }

      Inc(Index);

      if Index > Length(TempStr) then Inc(CurrentWord);
    end; { while }

  if CurrentWord <> Nr then WordStr := '';
  ExtractWord := WordStr;
end; { func. ExtractWord }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

{$IFDEF MSDOS}
procedure RemoveWordNrA(var TempStr: String; Nr: Word; CharAbortSet: CharSet; DoQuotes: Boolean);
{$ELSE}
procedure RemoveWordNrA(var TempStr: AnsiString; Nr: Word; CharAbortSet: CharSet; DoQuotes: Boolean);
{$ENDIF}
var Index       : Longint;
    CurrentWord : Longint;
    WordStr     : String;
begin
  CurrentWord := 01;
  Index := 01;
  WordStr := '';

  While ((Index) <= Length(TempStr)) AND (TempStr[Index] in CharAbortSet) do
    Inc(Index);

  While (Index <= Length(TempStr)) do
    begin
      if (TempStr[Index] in CharAbortSet) OR (Index > Length(TempStr)) then
        begin
          Inc(CurrentWord);

          While ((Index + 01) <= Length(TempStr)) AND (TempStr[Index + 01] in CharAbortSet) do
             begin
               WordStr := WordStr + TempStr[Index];
               Inc(Index);
             end; { while }
        end; { if }

      if TempStr[Index] = '"' then
        if DoQuotes then
          begin
            Inc(Index);

            While (Index <= Length(TempStr)) AND (TempStr[Index] <> '"') do
              begin
                Inc(Index);
              end; { while }

            Inc(CurrentWord);

            While ((Index + 01) <= Length(TempStr)) AND (TempStr[Index + 01] in CharAbortSet) do
               Inc(Index);
          end; { if }

      if CurrentWord <> Nr then
        if Index <= Length(TempStr) then WordStr := WordStr + TempStr[Index];
      Inc(Index);
    end; { word count }

  TempStr := WordStr;
end; { proc. RemoveWordNr }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

procedure RemoveWordNr(var TempStr: String; Nr: Word; CharAbortSet: CharSet; DoQuotes: Boolean);
{$IFDEF MSDOS}
var TusStr: String;
{$ELSE}
var TusStr: AnsiString;
{$ENDIF}
begin
  TusStr := TempStr;
  RemoveWordNrA(TusStr, Nr, CharAbortSet, DoQuotes);
  TempStr := TusStr;
end; { proc. RemoveWordnr }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

function Wordcount(TempStr: String; CharAbortSet: CharSet; DoQuotes: Boolean): Integer;
var Index       : Longint;
    CurrentWord : Longint;
begin
  Index := 01;
  CurrentWord := 00;

  While ((Index) <= Length(TempStr)) AND (TempStr[Index] in CharAbortSet) do
    Inc(Index);

  While (Index <= Length(TempStr)) do
    begin
      if (TempStr[Index] in CharAbortSet) OR (Index = Length(TempStr)) then
        begin
          Inc(CurrentWord);

          While ((Index + 01) <= Length(TempStr)) AND (TempStr[Index + 01] in CharAbortSet) do
             Inc(Index);
        end; { if }


      if TempStr[Index] = '"' then
        if DoQuotes then
          begin
            Inc(Index);

            While (Index <= Length(TempStr)) AND (TempStr[Index] <> '"') do
              begin
                Inc(Index);
              end; { while }

            Inc(CurrentWord);
            While ((Index + 01) <= Length(TempStr)) AND (TempStr[Index + 01] in CharAbortSet) do
               Inc(Index);
          end; { if }

      Inc(Index);
    end; { while }

  WordCount := CurrentWord;
end; { func. WordCount }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

function  GetValue(ID: String; var Str: String; Remove: Boolean): String;       { Get ID from Str }
var TempStr : String;
{$IFNDEF FPC}
{$IFNDEF WIN32}
  {$IFNDEF OS2}
    Result  : String;
  {$ENDIF}
{$ENDIF}
{$ENDIF}
begin
 Result := '';
 GetValue := '';
 If Pos(SUpcase(ID), SUpcase(Str))=00 then Exit;

 TempStr := Copy(Str, Pos(SUPcase(ID), SUpcase(Str)) + Pred(Length(ID)), Length(Str));

 If Pos(#32, TempStr)=00 then Result := TempStr
  else Result := Copy(TempStr, 1, Pos(#32, TempStr)-1);

 If Remove then Replace(ID + Copy(Result, 2, 255), '', Str);

 Getvalue := Copy(Result, 2, 255);
end; { func. Getvalue }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

function  InQuotes(S:String): String;
var Counter: Longint;
    TempStr: String;
begin
  TempStr := '';

  Counter := 01;

  If Length(S)>0 then
   While (Counter<=Length(S)) AND (S[Counter] <> '"') do
    Inc(Counter);

  If S[Counter]='"' then
   begin
     Inc(Counter);

     While (Counter<=Length(S)) AND (S[Counter] <> '"') do
      begin;
        TempStr := TempStr + S[Counter];
        Inc(Counter);
      end; { while }
   end; { If S[Counter] }

   InQuotes := TempStr;
end; { Counter }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

function  GetCommaArgument(S: String; Nr:Byte): String;
var Counter  : Byte;
    Commas   : Byte;
    TempStr  : String;
begin
  GetCommaArgument := '';

  Commas := 01;
  TempStr := '';

  For Counter := 01 to Length(S) do
    begin;
     If S[Counter]=',' then Inc(Commas);

     If S[Counter] <> ',' then
      If Commas=Nr then TempStr := TempStr + S[Counter];

     If Commas>Nr then break;
    end; { Commas }

 GetCommaArgument := TempStr;
end; { func. GetCommaArgument }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-*)

function InitialString(FromWho: String): String;
var TempStr : String;
    MaxLen  : Byte;
    Tmp     : String;
begin
  TempStr := '';

  MaxLen := 01;
  While (Trim(FromWho)<>'') AND (MaxLen<14) do
    begin
       Tmp := Trim(FirstWord(FromWho, defExtractWord, false));

       TempStr := TempStr + UpCase(Tmp[1]);
    end; { while }

  InitialString := TempStr;
end; { func. InitialString }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-*)

function FirstNameOnly(Str: String): String;
begin
  If Pos(#32, Str)>00 then FirstNameOnly := Copy(Str, 1, Pos(#32, Str)-1)
   else FirstNameOnly := Str;
end; { func. FirstNameOnly }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-*)

Function LastNameOnly(Str: String): String;
begin
  LastNameOnly := '';
  If Pos(#32, Str)>00 then LastNameOnly := Copy(Str, Pos(#32, Str)+1, Length(Str));
end; { func. LastNameOnly }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-*)

{$IFDEF MSDOS}
procedure ReplaceA(Const Zoek_Voor, Vervang_Door:String; Var Str : String);
{$ELSE}
procedure ReplaceA(Const Zoek_Voor, Vervang_Door:AnsiString; Var Str : AnsiString);
{$ENDIF}
var PosCNT : Longint;
begin
  PosCnt := Pos(SupCaseA(Zoek_Voor), SupCaseA(Str));
  if poscnt=0 then exit;

  Delete(Str, PosCnt, Length(Zoek_Voor) );
  Insert(Vervang_Door, Str, PosCnt);
end; { proc. ReplaceA }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-*)

procedure Replace(Const Zoek_Voor, Vervang_Door:String; Var Str : String);
{$IFDEF MSDOS}
var Str_Tmp: String;
{$ELSE}
var Str_Tmp: AnsiString;
{$ENDIF}
begin
  Str_Tmp := Str;

  ReplaceA(Zoek_Voor, Vervang_Door, Str_Tmp);

  Str := Str_Tmp;
end; { proc. Replace }
(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-*)


{$IFNDEF MSDOS}
function  FirstWordA(var s:AnsiString; CharAbortSet: CharSet; DoQuotes: Boolean):AnsiString;
{$ELSE}
function  FirstWordA(var s:String; CharAbortSet: CharSet; DoQuotes: Boolean):String;
{$ENDIF}
begin
  FirstWordA := '';

  S := Trim(S);
  If Length(S)=00 then Exit;

  FirstWordA := ExtractWord(S, 1, CharAbortSet, DoQuotes, false);

  if WordCount(S, CharAbortSet, DoQuotes) > 1 then
    begin
      RemoveWordNrA(S, 1, CharAbortSet, DoQuotes);
    end
       else S := '';

  S:=Trim(S);
end; { func. FirstWordA }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*-*)

Function  FirstWord(var s:String; CharAbortSet: CharSet; DoQuotes: Boolean):String; { first word of string & remove it }
begin
  FirstWord := '';

  S := Trim(S);
  If Length(S)=00 then Exit;

  FirstWord := ExtractWord(S, 1, CharAbortSet, DoQuotes, false);

  if WordCount(S, CharAbortSet, DoQuotes) > 1 then
    begin
      RemoveWordNr(S, 1, CharAbortSet, DoQuotes);
    end
       else S := '';

  S:=Trim(S);
end; { func. FirstWord }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

function LastWord(TempStr: String; CharAbortSet: CharSet; DoQuotes: Boolean): String;
begin
  LastWord := ExtractWord(TempStr, WordCount(TempStr, CharAbortSet, DoQuotes),
                          CharAbortSet, DoQuotes, false);
end; { func. LastWord }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

{$IFDEF MSDOS}
  procedure DoWrapA(var DestStr, LeftOver: String; MaxLen: Longint);
{$ELSE}
  procedure DoWrapA(var DestStr, LeftOver: AnsiString; MaxLen: Longint);
{$ENDIF}
Const NextWordChars : CharSet = [' ', ',', '.', ')', ']',
                                 '_', '!', '?', '*', #10, #00];

var Counter: Longint;
    TempStr: String;
begin
  TempStr := '';
  LeftOver := '';

  if DestStr[Length(DestStr)] in NextWordChars then
   if Length(DestStr) <= MaxLen then
    begin
      EXIT;
    end; { if }

  {------------------ Scan backwards for a string ---------------------------}
  Counter := Length(DestStr);
  While Counter > 1 do
    begin
      TempStr := DestStr[Counter] + TempStr;

      if DestStr[Counter] in NextWordChars then
       if Counter <= MaxLen then
         begin
           LeftOver := Copy(TempStr, 2, Length(TempStr) - 1);
           DestStr := Copy(DestStr, 1, Length(DestStr) - (Length(LeftOver)));
           BREAK;
         end; { if }

      Dec(Counter);
    end; { while }

end; { proc. DoWrap }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

procedure DoWrap(var DestStr, LeftOver: String; MaxLen: Longint);
{$IFDEF MSDOS}
var TmpDest: String;
    TmpLeft: String;
{$ELSE}
var TmpDest: AnsiString;
    TmpLeft: AnsiString;
{$ENDIF}
begin
  TmpDest := DestStr;
  TmpLeft := LeftOver;

  DoWrapA(TmpDest, TmpLeft, MaxLen);

  DestStr := TmpDest;
  LeftOver := TmpLeft;
end; { proc. DoWrap }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

procedure FilterString(var S: String; Chars: CharSet);
var TempStr: String;
    Counter: Longint;
begin
  TempStr := '';

  for Counter := 01 to Length(s) do
    if (S[Counter] in Chars) then TempStr := TempStr + S[Counter];

  S := TempStr;
end; { proc. FilterString }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

procedure RemoveChars(var S: String; Chars: CharSet);
var TempStr: String;
    Counter: Longint;
begin
  TempStr := '';

  for Counter := 01 to Length(s) do
    if (NOT (S[Counter] in Chars)) then TempStr := TempStr + S[Counter];

  S := TempStr;
end; { proc. RemoveChars }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)


end. { unit WORDSTR }
